%FigureGMA_script_RBG.m
close all;
fid = fopen('fitdata20071127_1035.txt', 'r');
A = fscanf(fid, '%d', [6 inf]);
fclose(fid);
A = A';
A = [A(1:7,5) A(1:7,6)];
A = A';
m = 1;

b = A( :, ((m-1)*7+1):m*7 );
b = sortrows(b',1)';
b = [[0 0]' b [8 255]'];

y   = b(2,:);
lum = b(1,:)/8;
clear param;

V = version;   %this is the matlab version
if (str2num(V(1))==7)
  options = statset('Display','iter');  %the usual case. 6 is for older PCs
  [param,r,J,COVB,mse] = nlinfit([y' lum'], zeros(length(b),1), @objfunc_relativeLum, [1], options);
else
  param = nlinfit([y' lum'], zeros(length(b),1), @objfunc_relativeLum, [1]);
end

sse = sum(objfunc_relativeLum(param, [y' lum']).^2);
sse2 = sum(r.^2);
if ( abs(sse-sse2) > 1.e-6)
    error('BAD sse');
end

gamma_rel = param;

xlum = 0:0.001:1;
sfunc = 255*(xlum.^(1/gamma_rel));

commonFontSize = 30;
commonMarkerSize = 20;
primaryAxes = [ 0 256 0 1];
rightAxisYLimits = [-0.03 0.03];
[ figHandle ax1Han  theNewAxisHandle ] = setupTwoAxisPlot(commonFontSize,primaryAxes, rightAxisYLimits );
plot(ax1Han,y,lum,  'o', 'Color', 'red', 'LineWidth', 2, 'MarkerSize', commonMarkerSize); hold on
plot(ax1Han, sfunc,xlum, 'color', 'blue', 'LineWidth', 2);
Npts = 9;
intv= 1;
plot(theNewAxisHandle, y,r,'ko','MarkerFaceColor','k', 'MarkerSize', commonMarkerSize);

ylabel(ax1Han,'Relative Luminance');
xlabel(ax1Han,'Pixel Bit Value');
%titleString = 'Gamma Curve With Psychophysical Calibration';
titleString = sprintf('Gamma Curve With Psychophysical Calibration, sse = %6.4f, \\gamma=%5.3f', sse, gamma_rel);
title(ax1Han,titleString)
legend(ax1Han,'Samples', [' \gamma_{rel} =' num2str(gamma_rel,'%6.4f')], 'Location', 'NorthWest')
%legend(ax1Han,'boxoff')

% figure; 
% plot(lum, y, 'o', 'Color', 'red', 'LineWidth', 2); hold on
% 
% plot(xlum, sfunc, 'color', 'blue', 'LineWidth', 2);
% 
% legend('Samples', ['Fitted curve, \gamma_{rel} =' num2str(gamma_rel,'%6.4f')], 'Location', 'NorthWest')
% 
% xlabel('Relative Luminance R(y)', 'FontSize', 14);
% ylabel('Gray level y', 'FontSize', 14);
% axis([0 1 0 255]);
% grid on;
% 
% set(gca, 'FontSize', 14);
% set(gca, 'xtick', 0:1/8:1, 'xticklabel', 0:1/8:1);  
% set(gca, 'ytick', [0:64:255 255], 'yticklabel', [0:64:255 255]);  

saveas(figHandle, 'CRT_RelLum.emf');




lumfile = 'ls100_255BackGround.log';
lum = parse_luminancedata(lumfile);

initparam = [min(lum) max(lum) 1];
options = statset('Display','iter');
y = (0:255);
 [param,r,J,COVB,mse] = nlinfit([y' lum'], zeros(length(y),1), @objfunc_absoluteLum, initparam, options);
minlum = param(1);
maxlum = param(2);
gamma_abs  = param(3);
sse2 = sum(r.^2);

abslum = ((y/255).^gamma_abs)*(maxlum-minlum)+minlum;


primaryAxes = [ 0 256 0 100];
rightAxisYLimits = [-0.03 0.03];
[ figHandle2 ax1Han  theNewAxisHandle ] = setupTwoAxisPlot(commonFontSize,primaryAxes, rightAxisYLimits );
plot(ax1Han, y(1:15:end),lum(1:15:end), 'o', 'Color', 'red', 'LineWidth', 2, 'MarkerSize', commonMarkerSize); hold on; %% movefig; 
% 
plot(ax1Han,y,abslum , '-', 'color', 'blue', 'LineWidth', 2);
plot(theNewAxisHandle, y(1:15:end),r(1:15:end),'ko','MarkerFaceColor','k', 'MarkerSize', commonMarkerSize);
ylabel(ax1Han,'Absolute Luminance (cd/m^2)' );
xlabel(ax1Han,'Pixel Bit Value');
%titleString = 'Gamma Curve With Photometer Calibration';
titleString = sprintf('Gamma Curve With Photometer Calibration, sse = %6.4f, \\gamma=%5.3f', sse2, gamma_abs);

title(ax1Han,titleString)
legend(ax1Han,'Samples', [' \gamma_{abs} =' num2str(gamma_abs,'%6.4f')], 'Location', 'NorthWest')
%legend(ax1Han,'boxoff')
% figure; 
% plot(lum(1:15:end), y(1:15:end), 'o', 'Color', 'red', 'LineWidth', 2); hold on; %% movefig; 
% 
% plot(abslum, y , '-', 'color', 'blue', 'LineWidth', 2);
% 
% legend('Samples', ['Fitted curve, \gamma_{abs} =' num2str(gamma_abs,'%6.4f')], 'Location', 'NorthWest')
% 
% xlabel('Absolute Luminance A(y) (cd/m^2)', 'FontSize', 14);
% ylabel('Gray level y', 'FontSize', 14);
% axis([0 maxlum 0 255]);
% grid on;
% 
% set(gca, 'FontSize', 14);
% %% set(gca, 'xtick', 0:1/8:1, 'xticklabel', 0:1/8:1);  
% set(gca, 'ytick', [0:64:255 255], 'yticklabel', [0:64:255 255]);  

saveas(figHandle2, 'CRT_AbsLum.emf');
