clear;

%this will delete from the SD calculation any points that are > 2SD off the
%mean, and also remove any points with imaginary values (IE points where
%the patch luminance is greater than the meanBGLum
removeOutlierPoints = true;
stdLimit = 2;
commonFontSize=24;

 fid  = fopen('CRTDataForStats.txt','wt');
fprintf(fid,'%s\r','CRT_Photometric');
fprintf(fid,'%s\r','Intended,Mean,STD(outliesrRemoved),Blank,Measured(10 items)');
intendeds = (0:0.1:2.5)';

%this will take points that have negative contrast and take the absolute
%value of them before calculating the SD
treatNegativeContrastAsPositive = false;

datadir = 'Tpaperplots/';
D = dir([datadir 'CalibrationLogfile_20080414_152723_ls100.xls']);
[ A a  meanBGLum] = showcontrast(commonFontSize,datadir, D);
saveas(gca, 'Tpaperplots\CRT_Photometer_Verification.tif')

Nfore = 27;
for i = 1:26
  s0 = A(i:Nfore:end,6);
  s1 = -log10(1 - s0./meanBGLum);
  
  if(treatNegativeContrastAsPositive)
      idxImag =  find(imag(s1)~=0);
      if(~isempty(idxImag))
        s1(idxImag) = -log10(1 - meanBGLum/s0(idxImag));
      end
  end

  if(removeOutlierPoints )
      [ nimag noutlier theMean  realCSstd(i)  ] = std_withOutlierRemoval( s1, stdLimit );
  else
        realCSstd(i) = std(s1);
  end
  fprintf(fid,'\r%10.4f,%10.4f,%10.4f,,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f',intendeds(i),theMean,realCSstd(i),s1);


end

%close all;
figure; 
%errorbar(1.8:0.1:2.5, a(19:26,1), realCSstd(19:26), 'o', 'LineWidth', 2); grid on; %% movefig;
errorbar(1.8:0.1:2.4, a(19:25,1), realCSstd(19:25), 'o', 'LineWidth', 2); grid on; %% movefig;
hold on; plot(1.7:0.1:2.55, 1.7:0.1:2.55, 'red');

axis equal
axis([1.7 2.55 1.7 2.55]);
title('');
xlabel('Intended Log Contrast','FontSize',commonFontSize);
ylabel('Measured Log Contrast','FontSize',commonFontSize);
set(gca,'FontSize',commonFontSize-10)
%legend('Measured Contrast', 'Wanted Contrast', 'Location', 'SouthEast');
text(1.75,2.45,'CRT-Photometric','FontSize',commonFontSize)
saveas(gca, 'Tpaperplots\CRT_Photometer_ErrorBar.tif')


%clear;
removeOutlierPoints = true;
stdLimit = 2;
commonFontSize=24;
datadir = 'Tpaperplots/';
D = dir([datadir 'CalibrationLogfile_20080414_160316_psy.xls']);
[ A a meanBGLum] = showcontrast(commonFontSize,datadir, D);
saveas(gca, 'Tpaperplots\CRT_Psy_Verification.tif')


fprintf(fid,'%s\r','CRT_Psychophsical');
fprintf(fid,'%s\r','Intended,Mean,STD(outliesrRemoved),Blank,Measured(10 items)');


Nfore = 26;
for i = 1:25
  s0 = A(i:Nfore:end,6);
  s1 = -log10(1 - s0./meanBGLum);
  
  
  if(removeOutlierPoints )
      [ nimag noutlier theMean  realCSstd(i)  ] = std_withOutlierRemoval( s1, stdLimit );
  else
        realCSstd(i) = std(s1);
  end
  fprintf(fid,'\r%10.4f,%10.4f,%10.4f,,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f',intendeds(i),theMean,realCSstd(i),s1);
  

end

%close all;
fclose(fid);
figure; 
errorbar(1.8:0.1:2.4, a(19:25,1), realCSstd(19:25), 'o', 'LineWidth', 2); grid on; %% movefig;
hold on; plot(1.7:0.1:2.5, 1.7:0.1:2.5, 'red');

axis equal
axis([1.7 2.55 1.7 2.55]);
title('');
xlabel('Intended Log Contrast','FontSize',commonFontSize);
ylabel('Measured Log Contrast','FontSize',commonFontSize);
set(gca,'FontSize',commonFontSize-10)
%legend('Measured Contrast', 'Wanted Contrast', 'Location', 'SouthEast');
text(1.75,2.45,'CRT-Psychophysical','FontSize',commonFontSize)
saveas(gca, 'Tpaperplots\CRT_Psy_ErrorBar.tif')
close all;