clear;

%this will delete from the SD calculation any points that are > 2SD off the
%mean, and also remove any points with imaginary values (IE points where
%the patch luminance is greater than the meanBGLum
removeOutlierPoints = true;
stdLimit = 2;
commonFontSize = 24;


%this will take points that have negative contrast and take the absolute
%value of them before calculating the SD
treatNegativeContrastAsPositive = true;

 fid  = fopen('LCDDataForStats.txt','wt');


fprintf(fid,'%s\r','LCD_Psycophysical');
fprintf(fid,'%s\r','Intended,Mean,STD(outliesrRemoved),Blank,Measured(10 items)');
intendeds = (0:0.1:2.5)';
load 'Tpaperplots/20080324_142423_Janus_LCD_PsyCalibration_gamma1.8.mat';

for i = 1:26
  s0 = A(i:Nfore:end,4);
  s1 = -log10(1 - s0./meanBGLum);
  if(removeOutlierPoints )
      [ nimag noutlier theMean  realCSstd(i)  ] = std_withOutlierRemoval( s1, stdLimit );
  else
        realCSstd(i) = std(s1);
  end
  fprintf(fid,'\r%10.4f,%10.4f,%10.4f,,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f',intendeds(i),theMean,realCSstd(i),s1);
end
fprintf(fid,'\r\r\r',0,0,0);
a = [realCS' (0:0.1:2.5)' B(1:26,:) realCSstd'];

close all;
figure; 
plot(a(1:25,2), a(1:25,1), 'x', 'LineWidth', 2); grid on; %% movefig;
hold on; plot(0:0.1:2.5, 0:0.1:2.5, 'red');

axis equal
axis([0 2.5 0 2.5]);
%% title('gamma1.8');
xlabel('Intended Log Contrast','FontSize',commonFontSize);
ylabel('Measured Log Contrast','FontSize',commonFontSize);
set(gca,'FontSize',commonFontSize-10)
%legend('Measured Contrast', 'Wanted Contrast', 'Location', 'SouthEast');
text(1.75,2.45,'LCD-Psychophysical','FontSize',commonFontSize)
saveas(gca, 'Tpaperplots\LCD_Psy_Verification.tif')
set(gca,'FontSize',commonFontSize-10)

close all;
figure; 
errorbar(a(19:25,2), a(19:25,1), a(19:25,7), 'o', 'LineWidth', 2); grid on; %% movefig;
hold on; plot(1.7:0.1:2.5, 1.7:0.1:2.5, 'red');

axis equal
axis([1.7 2.5 1.7 2.5]);
title('');
xlabel('Intended Log Contrast','FontSize',commonFontSize);
ylabel('Measured Log Contrast','FontSize',commonFontSize);
%legend('Measured Contrast', 'Wanted Contrast', 'Location', 'SouthEast');
text(1.75,2.45,'LCD-Psychophysical','FontSize',commonFontSize)
set(gca,'FontSize',commonFontSize-10)
saveas(gca, 'Tpaperplots\LCD_Psy_ErrorBar.tif')


clear;
load 'Tpaperplots/20080321_101517_Janus_LCD_ATI_Gamm1.8.mat';


%this will delete from the SD calculation any points that are > 2SD off the
%mean, and also remove any points with imaginary values (IE points where
%the patch luminance is greater than the meanBGLum
removeOutlierPoints = true;
stdLimit = 2;
commonFontSize = 24;

fprintf(fid,'\r\r%s\r','LCD_Photometric');
fprintf(fid,'%s\r','Intended,Mean,STD(outliesrRemoved),Blank,Measured(10 items)');
intendeds = (0:0.1:2.5)';
for i = 1:26
  s0 = A(i:Nfore:end,4);
  s1 = -log10(1 - s0./meanBGLum);
  
  if(removeOutlierPoints )
      [ nimag noutlier theMean  realCSstd(i)  ] = std_withOutlierRemoval( s1, stdLimit );
  else
        realCSstd(i) = std(s1);
  end
  fprintf(fid,'\r%10.4f,%10.4f,%10.4f,,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f,%10.4f',intendeds(i),theMean,realCSstd(i),s1);

end

a = [realCS' (0:0.1:2.5)' B(1:26,:) realCSstd'];
fclose(fid);
close all;
figure; 
plot(a(1:25,2), a(1:25,1), 'x', 'LineWidth', 2); grid on; %% movefig;
hold on; plot(0:0.1:2.5, 0:0.1:2.5, 'red');

axis equal
axis([0 2.5 0 2.5]);
%% title('gamma1.8');
xlabel('Intended Log Contrast','FontSize',commonFontSize);
ylabel('Measured Log Contrast','FontSize',commonFontSize);
set(gca,'FontSize',commonFontSize-10)
%legend('Measured Contrast', 'Wanted Contrast', 'Location', 'SouthEast');
set(gca,'FontSize',commonFontSize-10)
text(1.75,2.45,'LCD-Photometric','FontSize',commonFontSize)
saveas(gca, 'Tpaperplots\LCD_Photometer_Verification.tif');


close all;
figure; 
%errorbar(a(1:25,2), a(1:25,1), a(1:25,7), 'o', 'LineWidth', 2); grid on; %% movefig;
errorbar(a(19:25,2), a(19:25,1), a(19:25,7), 'o', 'LineWidth', 2); grid on; %% movefig;
hold on; plot(1.7:0.1:2.5, 1.7:0.1:2.5, 'red');

axis equal
axis([1.7 2.5 1.7 2.5]);
title('');
xlabel('Intended Log Contrast','FontSize',commonFontSize);
ylabel('Measured Log Contrast','FontSize',commonFontSize);
%legend('Measured Contrast', 'Wanted Contrast', 'Location', 'SouthEast');
text(1.75,2.45,'LCD-Photometric','FontSize',commonFontSize)
set(gca,'FontSize',commonFontSize-10)

saveas(gca, 'Tpaperplots\LCD_Photometer_ErrorBar.tif')
close all;