function [ A a meanBGLum]= showcontrast(commonFontSize,datadir, D)

filename = [datadir D(end).name];

CSMeasureFile = filename;
fid = fopen(CSMeasureFile, 'r');
A = fscanf(fid, '%f', [9 Inf]);
fclose(fid);
A = A';

Nsamples = A(1,1);
Nsets = A(1,2); 

A = A(2:end, :);

%% Nsamples = 27;

for i = 1:size(A,1)/Nsamples
  startIDX = (i-1)*Nsamples+1;
  endIDX   = i*Nsamples;
  D = A(startIDX:endIDX,:);
  D(A(startIDX:endIDX,1)+1,:) = D;
  A(startIDX:endIDX,:) = D;
end

C = A(1:Nsamples,:);

for i = 1:Nsamples
  C(i,6) = mean2(A(i:Nsamples:end,6));
end

meanBGLum = C(end,6);

for i = 1:(Nsamples-1)
  meanLum(i)   = C(i,6);
  if (meanLum(i)<meanBGLum)
    realCS(i) = -log10(1 - meanLum(i)/meanBGLum);
  else
    realCS(i) = 3.00;
  end
end

a = [realCS' C(1:(Nsamples-1),[4 6 7:9])];
%% a = sortrows(a,2);
close all;
figure; 
plot((0:(Nsamples-2))/10, a(1:(Nsamples-1),1) , 'x', 'LineWidth', 2); grid on;
%% plot(a(1:(Nsamples-1),2), a(1:(Nsamples-1),1), 'x', 'LineWidth', 2); grid on;
hold on; plot(0:0.1:2.5, 0:0.1:2.5, '-', 'color', 'red');
axis equal
axis([0 2.5 0 2.5]);
xlabel('Wanted Contrast (logCS)','FontSize',commonFontSize);
ylabel('Actual Contrast (logCS) (average)','FontSize',commonFontSize);
set(gca,'FontSize',commonFontSize-10)
legend('Measured Contrast', 'Wanted Contrast', 'Location', 'SouthEast');
% saveas(gca, [filename '.tif']);
end
