function [ nimag noutlier theMean theStd  ] = std_withOutlierRemoval( A, stdLimit )
%std_withOutlierRemoval 
%  takes the array STD.  It removes imaginary values and also removes
%  points that have values > stdLimit standard Deviations off the mean. It
%  then recalculates the mean and STD.

N = length(A);
idxReal =  find(imag(A)==0);

A1 = A(idxReal);

nimag = length(A)-length(A1);
theMean = mean(A1);
theStd = std(A1);

dist = abs(A1-theMean);

idxNotOutlier = find(dist < stdLimit*theStd);
A2 = A1(idxNotOutlier);
noutlier = length(A1)-length(A2);

theMean = mean(A2);
theStd = std(A2);

end

